local assignSoldier = ...

--------------------------------------------------------------------------
local ASSIGN_SOLDIER_LADDER_TILLING_COMP = {
	TypeName = "ASSIGN_SOLDIER_LADDER_TILLING_COMP",
	ParentType = "COMPONENT",
	Properties = {
	}
}
assignSoldier:registerClass(ASSIGN_SOLDIER_LADDER_TILLING_COMP)

--------------------------------------------------------------------------
local ASSIGN_SOLDIER_LADDER_TILLING_UP_COMP = {
	TypeName = "ASSIGN_SOLDIER_LADDER_TILLING_UP_COMP",
	ParentType = "COMPONENT",
	Properties = {
	}
}
assignSoldier:registerClass(ASSIGN_SOLDIER_LADDER_TILLING_UP_COMP)

--------------------------------------------------------------------------
local ASSIGN_SOLDIER_LADDER_TILLING_BASE_COMP = {
	TypeName = "ASSIGN_SOLDIER_LADDER_TILLING_BASE_COMP",
	ParentType = "COMPONENT",
	Properties = {
	}
}
assignSoldier:registerClass(ASSIGN_SOLDIER_LADDER_TILLING_BASE_COMP)

--------------------------------------------------------------------------
local ASSIGN_SOLDIER_PATH_AEND_COMP = {
	TypeName = "ASSIGN_SOLDIER_PATH_AEND_COMP",
	ParentType = "COMPONENT",
	Properties = {
		{ Name = "WorkplaceCustom", Type = "string", Default = "Woop" }
	}
}

--------------------------------------------------------------------------
function ASSIGN_SOLDIER_PATH_AEND_COMP:create()
    self._isSet = false
end

--------------------------------------------------------------------------
function ASSIGN_SOLDIER_PATH_AEND_COMP:init()
    assignSoldier:msgBox("AssignSoldier: ASSIGN_SOLDIER_PATH_AEND_COMP:init" .. tostring(self:getOwner():getGlobalPosition()))
    if self.WorkplaceCustom == "Arrow" then
        assignSoldier:msgBox("AssignSoldier: ASSIGN_SOLDIER_PATH_AEND_COMP:init Arrow")
        self.guardLocatorList = { self:getOwner() }
        assignSoldier:msgBox("AssignSoldier: guardLocatorList initialized" .. tostring(self.guardLocatorList[1]:getGlobalPosition()))
    elseif self.WorkplaceCustom == "KeepTrap" then
        assignSoldier:msgBox("AssignSoldier: ASSIGN_SOLDIER_PATH_AEND_COMP:init KeepTrap")
        self.guardLocatorList = {}
--        self:adjustLadder()
    elseif self.WorkplaceCustom == "KeepTrapAccess" then
        assignSoldier:msgBox("AssignSoldier: ASSIGN_SOLDIER_PATH_AEND_COMP:init KeepTrapAccess")
        self.guardLocatorList = {}
--        self:adjustLadder()
    else
        assignSoldier:msgBox("AssignSoldier: ASSIGN_SOLDIER_PATH_AEND_COMP:init otherwise")
        self.guardLocatorList = {}
    end
    self._isSet = false
end

function ASSIGN_SOLDIER_PATH_AEND_COMP:getGroundElevation(_position)
    local raycastResult = {}
    -- Raycast from the building position Y + 100
    -- to building position Y - 1000
    -- only on objects with a TERRAIN flag
    local FromPosition = { _position[1], _position[2]+100, _position[3] }
    local ToPosition = { _position[1], _position[2]-1000, _position[3] }
    assignSoldier:log("FromPosition = " .. tostring(FromPosition) .. "ToPosition = " .. tostring(ToPosition))
    if not self:getLevel():rayCast(FromPosition, ToPosition, raycastResult, 2 ^ OBJECT_FLAG.TERRAIN:toNumber()) then
         assignSoldier:logWarning("assignSoldier: Wheel out of the map ?")
         return _position[2]
    end
    assignSoldier:log("final raycastResult = RigidBody = " .. tostring(raycastResult["RigidBody"]) .. " Position = " .. tostring(raycastResult["Position"]) .. " Normal = " .. tostring(raycastResult["Normal"]))
    assignSoldier:log("getGroundElevation = " .. raycastResult["Position"][2])
    return raycastResult["Position"][2]
end

function ASSIGN_SOLDIER_PATH_AEND_COMP:adjustLadder()
    assignSoldier:log("adjustLadder begin")
    local _ladderTilingComp = self:getOwner():findFirstObjectWithComponentDown("ASSIGN_SOLDIER_LADDER_TILLING_COMP")
    assignSoldier:log("adjustLadder _ladderTilingComp = " .. tostring(_ladderTilingComp))
    local _initialPosition = self:getOwner():findFirstObjectWithComponentDown("ASSIGN_SOLDIER_LADDER_TILLING_UP_COMP"):getOwner():getGlobalPosition()
    assignSoldier:log("adjustLadder InitialPosition = " .. tostring(_initialPosition))
    local _baseElevation = self:getGroundElevation(_initialPosition)
    assignSoldier:log("adjustLadder _baseElevation = " .. tostring(_baseElevation))
    local _ladderTilingSize = _initialPosition[2]
                            - self:getOwner():findFirstObjectWithComponentDown("ASSIGN_SOLDIER_LADDER_TILLING_BASE_COMP"):getOwner():getGlobalPosition()[2]
    assignSoldier:log("adjustLadder _ladderTilingSize = " .. tostring(_ladderTilingSize))
    local _ladderFactor = (_initialPosition[2] - _baseElevation)/_ladderTilingSize + 1
    assignSoldier:log("adjustLadder _ladderFactor = " .. tostring(_ladderFactor))
    _ladderTilingComp:getOwner():scale({1, _ladderFactor, 1})
    assignSoldier:log("adjustLadder scale updated")
--    _ladderTilingComp:getOwner():setGlobalPosition({_initialPosition[1], (_initialPosition[2] + _baseElevation)/2, _initialPosition[3]})
--    assignSoldier:log("adjustLadder position updated")
end

function ASSIGN_SOLDIER_PATH_AEND_COMP:registerPath(_pathLocator)
    assignSoldier:msgBox("AssignSoldier: insert locator")
    if _pathLocator == nil then
        assignSoldier:msgBox("AssignSoldier: _pathLocator nil")
        return
    end
    table.insert(self.guardLocatorList, _pathLocator)
end

function ASSIGN_SOLDIER_PATH_AEND_COMP:endRegisterPath(_pathLocator)
    self:registerPath(_pathLocator)
    assignSoldier:msgBox("AssignSoldier: loop on guardLocatorList")
    for i, _locator in ipairs(self.guardLocatorList) do
        assignSoldier:msgBox("AssignSoldier: update path " .. #self.guardLocatorList - i .. tostring(_locator:getGlobalPosition()))
        local _path = self:getOwner():findFirstObjectWithComponentDown("ASSIGN_SOLDIER_PATH_A" .. (#self.guardLocatorList - i) .. "_COMP")
        if (_path == nil) or (_locator == nil) then
            assignSoldier:msgBox("AssignSoldier: _path or _locator nil")
        else
            assignSoldier:msgBox("AssignSoldier: position update")
            _path:getOwner():setGlobalPosition({_locator:getGlobalPosition()[1], _locator:getGlobalPosition()[2]+100, _locator:getGlobalPosition()[3]})
            assignSoldier:msgBox("AssignSoldier: position updated" .. tostring(_path:getOwner():getGlobalPosition()))
        end
    end
    self._isSet = true
end

--------------------------------------------------------------------------
assignSoldier:registerClass(ASSIGN_SOLDIER_PATH_AEND_COMP)


